Bug 228545 - java.lang.RuntimeException: ClientAbortException: java.nio.channels.ClosedChannelException
java.lang.RuntimeException: ClientAbortException: java.nio.channels.ClosedCh...
Status: NEW
Product: serverplugins
Classification: Unclassified
Component: GlassFish
7.3
PC Windows 7
: P3 (vote)
: 7.4
Assigned To: TomasKraus
issues@serverplugins
NB_AND_SDK
: REGRESSION
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2013-04-14 09:31 UTC by MackSix
Modified: 2013-07-19 23:04 UTC (History)
0 users

See Also:
Issue Type: DEFECT
:


Attachments
GlassFish Output RuntimeException (3.23 KB, text/plain)
2013-04-14 09:31 UTC, MackSix
Details

Note You need to log in before you can comment on or make changes to this bug.
Description MackSix 2013-04-14 09:31:38 UTC
Created attachment 133491 [details]
GlassFish Output RuntimeException

1. Start NetBeans
2. Start GlassFish from "GlassFish Server 3+" node's context menu in Services Window.
3. View the GlassFish Output Window.
4. From the "GlassFish Server 3+" node context menu, click "View Domain Server Log".
5. Click red, square "Stop the Server" button located on the left side of the GlassFish Output Window.
6. Observe RuntimeException in Output Window:


SEVERE: service exception
java.lang.RuntimeException: ClientAbortException:  java.nio.channels.ClosedChannelException
	at 
<snip>

(See attached file for full output.)

Expected in Output Window:

INFO: Server shutdown initiated
INFO: JMX002: JMXStartupService: Stopped JMXConnectorServer: null
Completed shutdown of Log manager service

Clicking the "View Domain Server" button causes this.

Works OK on v7.2.1, regression.

Product Version: NetBeans IDE 7.3 (Build 201302132200)
Java: 1.7.0_17; Java HotSpot(TM) 64-Bit Server VM 23.7-b01
Runtime: Java(TM) SE Runtime Environment 1.7.0_17-b02
System: Windows 7 version 6.1 running on amd64; UTF-8; en_US (nb)
Comment 1 MackSix 2013-04-14 09:52:29 UTC
Bug also in:

Product Version: NetBeans IDE Dev (Build 201304131047)
Java: 1.7.0_17; Java HotSpot(TM) 64-Bit Server VM 23.7-b01
Runtime: Java(TM) SE Runtime Environment 1.7.0_17-b02
System: Windows 7 version 6.1 running on amd64; Cp1252; en_US (nb)
Comment 2 TomasKraus 2013-04-15 13:05:59 UTC
I remember this bug but I'm unable to reproduce this in last 7.3.1 build. Tested with Glassfish 3.1.2.2 and GlassFish 4 dev build.

Please can you verify this with last 7.3.1 build from http://bertram2.netbeans.org:8080/job/web-main-javaee7/
Comment 3 MackSix 2013-04-15 15:33:45 UTC
(In reply to comment #2)
> I remember this bug but I'm unable to reproduce this in last 7.3.1 build.
> Tested with Glassfish 3.1.2.2 and GlassFish 4 dev build.
> 
> Please can you verify this with last 7.3.1 build from
> http://bertram2.netbeans.org:8080/job/web-main-javaee7/

It still happens, but now it is only reproducible/predictable if I restart NetBeans and then it will always do this the first time I start and stop GlassFish. I do not have to click on "View Domain Server" for this to happen now. It will still do it without restarting NetBeans, but it only did it the first time I closed the GlassFish Output Window and reopened it, then stopped the server. 

FYI: The Output Window is blank when close and reopened while GlassFish is running.
Comment 4 MackSix 2013-04-15 16:28:29 UTC
Now I deleted the directory and userdir and cachdir and unzipped the file again and ran it, reinitialized the plugins because of another bug when activating plugins for the first time. Now it is doing this every time I start it from the node context menu and stopping it with the red square button on the GlassFish output window. I don't know why it is different. 

I am using the Oracle GlassFish/Java EE 6 download, not the GlassFish installation that comes with NetBeans in every case.
Comment 5 TomasKraus 2013-04-15 19:45:52 UTC
Fortunately this exception is not critical and it won't damage everything.
Looks like the problem is in log output being closed before server is terminated.

I'll try to change this process to stop log reader after server stops responding.
Comment 6 TomasKraus 2013-04-16 14:10:30 UTC
It was not related to log reader. I missed
com.sun.enterprise.v3.admin.AdminAdapter.service(AdminAdapter.java:243)
in stack trace which is pointing to remote admin command interface.

I talked to GF admin interface developer and looks like server is being killed when there is still some admin command response waiting to be send back to NetBeans.

I went trough the code that is running remote admin commands on GlassFish and did not find anything wrong - connection is closed in finally block of try containing connect. Response is always read.

Looks like this will be another never ending issue. :(
Comment 7 TomasKraus 2013-04-16 14:21:05 UTC
Lowering this to P3 because it's not dangerous. Will try to fix it in 7.4 where I'll be doing some significant changes in server admin interface.
Comment 8 MackSix 2013-04-16 15:04:33 UTC
I notice that sometimes when I stop GlassFish3, when it doesn't give exceptions, it will give different stop messages.

Sometimes it says:

Completed shutdown of Log manager service
INFO: [Thread[GlassFish Kernel Main Thread,5,main]] exiting
Completed shutdown of GlassFish runtime

Sometimes:

Completed shutdown of Log manager service
Completed shutdown of GlassFish runtime

Sometimes it will just say:

Completed shutdown of Log manager service


By use of this website, you agree to the NetBeans Policies and Terms of Use. © 2012, Oracle Corporation and/or its affiliates. Sponsored by Oracle logo